library(ggplot2)
drawFig_S9=function(df, addPeaks, col2show, file, front, remap,nArray, array_replicate_colors){
  
  p <- ggplot(df, aes(X1, X2)) + geom_point(alpha=0.6, size=2, colour=col2show) + stat_density2d()  + coord_fixed()
  p <- p + geom_point(data=df[front,], aes(X1, X2), colour = col2show[front], size=2)
  p <- p + geom_point(data=remap[1:nArray,], aes(X1, X2), fill = array_replicate_colors, size=4, shape=23)
  
  
  
  
  if(addPeaks){
    p <- p + geom_point(data=peaks, aes(X1, X2), colour = "red", size=6.5, fill=NA, shape=1)
    p <- p + geom_point(data=peaks, aes(X1, X2), colour = "red", size=6, fill=NA, shape=1)  + stat_density2d()
    for (j in 1:dim(peaks)[1]){
      p <- p + annotate("text", label = as.character(j), x = peaks[j,1], y = peaks[j,2], size=3.5)
    }
  }
  ## p<- p + ggtitle(paste("Subpopulations","bandwidth",sig_tol_range)) + xlab("y1") + ylab("y2")
  ggsave(filename = paste(file,".pdf",sep=""))
  graphics.off()
  
}

# Windows
setwd("D:\\Research\\UTA\\Dropbox (Compbio)\\Projects\\Leukemia\\Data\\Fullmap")

#Reading in base data
coord =  read.table("data9544_15pct_BHSNE_mean-shift.txt", sep="\t", header=T, stringsAsFactors=F)
peaks = read.table("data9544_15pct_BHSNE_mean-shift_cluster_centroids_2.5.txt", sep="\t", header=T, stringsAsFactors=F)
d = read.table("USE_final_anno_columnIDsorted_data9544_withColorClass.txt", sep="\t", header=T, stringsAsFactors=F)
colnames(d)=c("gsm",  "series_id","Sample.type","Main.category","Category.specifying.lineage.tumor.origin",
              "Category.specifying.subtype","Further.specifications.on.category","GENETICS1","GENETICS2","Tumor.type",
              "CLINICAL","Sub.maps.available","Patient.identifier","Source","Isolation",
              "Purity.Tumor.cell.content","Gender","Race","Age","Marker.phenotype",
              "Survival.status..0.alive.1.dead.","Survival.time","EF.PF.status","EF.survival","G_S_P",
              "In.vivo.treatment","In.vivo.treatment.time","Cultured","Ex.vivo.treatment","Ex.vivo.treatment.time",
              "NOTES","altGSMs", "altGSEs", "CLASS","MAINCLASS")
only_coord = coord[,2:3]
all(d[,1]==coord[,1])
dd=cbind(d,coord)

#Reading in replicate data ----
#Windows
setwd("D:\\Research\\UTA\\Dropbox (Compbio)\\Projects\\Leukemia\\Submission\\Remapping\\Remapping_results")

remapped_array = read.table('remapped_fullmap_coordinates_fixed.txt',  sep="\t", header=T, stringsAsFactors=F)
nArray = nrow(remapped_array)
rownames(dd) = dd$gsm
remapped_array_counterparts = remapped_array[,1]
array_counterpart_ind = match(remapped_array_counterparts, dd[,1])
counterparts = dd[c(remapped_array_counterparts),38:39]

#Finishing data frame of remapped samples
remapped=rbind(remapped_array[,2:3])
nArray = nrow(remapped_array)
colnames(remapped)=c("X1","X2")
remapped[,1]=as.numeric(sub(",", ".", remapped[,1]))
remapped[,2]=as.numeric(sub(",", ".", remapped[,2]))

#Handling the coloring
dat2show=cbind(dd$x,dd$y)
df=as.data.frame(dat2show)
colnames(df) = c("X1","X2")
col2show=rep("grey", dim(dat2show)[1])
sig_tol_range=1.5
addPeaks=T
front=1:nrow(dat2show)%in%1:3

#Classes ----
uniq_classes = unique(dd$CLASS)
normk=1:nrow(dd)%in%c(grep("normal karyotype", dd$GENETICS1),grep("Normal", dd$GENETICS1),grep("CN", dd$GENETICS1),grep("NN",dd$GENETICS1))&(1:nrow(dd)%in%grep("Leukemia_AML",dd$CLASS))
## 867
AML=1:nrow(dd)%in%grep("Leukemia_AML",dd$CLASS) ##
CML=1:nrow(dd)%in%grep("Leukemia_CML",dd$CLASS) ##
preB_ALL=1:nrow(dd)%in%grep("pre-B-ALL",dd$CLASS) ##
B_CLL=1:nrow(dd)%in%grep("B-CLL",dd$CLASS) ##
BCL=1:nrow(dd)%in%grep("BCL",dd$CLASS) ##
MM=1:nrow(dd)%in%grep("MM",dd$CLASS) ##
T_ALL=1:nrow(dd)%in%grep("T-ALL",dd$CLASS) ##
TCL=1:nrow(dd)%in%grep("TCL",dd$CLASS) ##
Prolif_M = 1:nrow(dd)%in%grep("Prolif_M",dd$CLASS) ##
Prolif_L = 1:nrow(dd)%in%grep("Prolif_L",dd$CLASS) ##

col2show=rep("#bebcbbff", dim(dat2show)[1])
col2show[AML] = "#45b968ff"
col2show[CML] = "#22612eff"
col2show[preB_ALL] = "#d075c1ff"
col2show[B_CLL] = "#7b3fa3ff"
col2show[BCL] = "#b88389ff"
col2show[MM] = "#873859ff"
col2show[T_ALL] = "#708dd0ff"
col2show[TCL] = "#2b3f8eff"
col2show[Prolif_M] = "#c3e351ff"
col2show[Prolif_L] = "#f9b3ccff"
array_replicate_colors = col2show[array_counterpart_ind]

# Reverting coloring of cell lines to default light grey
cell_lines = 1:nrow(dd)%in%grep("CellLine", dd$CLASS)
col2show[cell_lines] = "#bebcbbff"
drawFig_S9(df, T, col2show, paste("fullmap_15pct_genes_remapped", sep=""), front, remapped, 
       nArray, array_replicate_colors)